# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

__revision__ = '$Id: stream.py 678 2008-08-08 11:22:14Z jajcus $'
__docformat__ = 'restructuredtext en'
import logging
from pyxmpp.streambase import StreamBase
from pyxmpp.streamtls import StreamTLSMixIn
from pyxmpp.streamsasl import StreamSASLMixIn

class Stream(StreamTLSMixIn, StreamSASLMixIn, StreamBase):
    
    def __init__(self, default_ns, extra_ns = (), sasl_mechanisms = (), tls_settings = None, keepalive = 0, owner = None):
        StreamBase.__init__(self, default_ns, extra_ns, keepalive, owner)
        StreamTLSMixIn.__init__(self, tls_settings)
        StreamSASLMixIn.__init__(self, sasl_mechanisms)
        self._Stream__logger = logging.getLogger('pyxmpp.Stream')

    
    def _reset(self):
        StreamBase._reset(self)
        self._reset_tls()
        self._reset_sasl()

    
    def _make_stream_features(self):
        features = StreamBase._make_stream_features(self)
        self._make_stream_tls_features(features)
        self._make_stream_sasl_features(features)
        return features

    
    def _process_node(self, xmlnode):
        if self._process_node_tls(xmlnode):
            return None
        
        if self._process_node_sasl(xmlnode):
            return None
        
        StreamBase._process_node(self, xmlnode)

    
    def _got_features(self):
        self._handle_tls_features()
        self._handle_sasl_features()
        StreamBase._got_features(self)
        if not (self.tls_requested) and not (self.authenticated):
            self.state_change('fully connected', self.peer)
            self._post_connect()
        


